# mypy-boto3-compute-optimizer

[![PyPI - mypy-boto3-compute-optimizer](https://img.shields.io/pypi/v/mypy-boto3-compute-optimizer.svg?color=blue)](https://pypi.org/project/mypy-boto3-compute-optimizer)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-compute-optimizer.svg?color=blue)](https://pypi.org/project/mypy-boto3-compute-optimizer)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.ComputeOptimizer 1.16.54](https://boto3.amazonaws.com/v1/documentation/api/1.16.54/reference/services/compute-optimizer.html#ComputeOptimizer) service
compatible with
[VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright)
and other tools.

Generated by [mypy-boto3-buider 4.3.1](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-compute-optimizer](#mypy-boto3-compute-optimizer)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Typed dictionations](#typed-dictionations)

## How to install

Install `boto3-stubs` for `ComputeOptimizer` service.

```bash
python -m pip install boto3-stubs[compute-optimizer]
```

## Usage

### VSCode

- Install [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[compute-optimizer]` in your environment: `python -m pip install 'boto3-stubs[compute-optimizer]'`

Both type checking and auto-complete should work for `ComputeOptimizer` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[compute-optimizer]` in your environment: `python -m pip install 'boto3-stubs[compute-optimizer]'`

Both type checking and auto-complete should work for `ComputeOptimizer` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[compute-optimizer]` in your environment: `python -m pip install 'boto3-stubs[compute-optimizer]'`
- Run `mypy` as usual

Type checking should work for `ComputeOptimizer` service.
No explicit type annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[compute-optimizer]` in your environment: `python -m pip install 'boto3-stubs[compute-optimizer]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `ComputeOptimizer` service.
No explicit type annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`ComputeOptimizerClient` provides annotations for `boto3.client("compute-optimizer")`.

```python
import boto3

from mypy_boto3_compute_optimizer import ComputeOptimizerClient

client: ComputeOptimizerClient = boto3.client("compute-optimizer")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: ComputeOptimizerClient = session.client("compute-optimizer")
```








### Typed dictionations

`mypy_boto3_compute_optimizer.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_compute_optimizer.type_defs import (
    AutoScalingGroupConfigurationTypeDef,
    AutoScalingGroupRecommendationOptionTypeDef,
    AutoScalingGroupRecommendationTypeDef,
    DescribeRecommendationExportJobsResponseTypeDef,
    EBSFilterTypeDef,
    EBSUtilizationMetricTypeDef,
    ExportAutoScalingGroupRecommendationsResponseTypeDef,
    ExportDestinationTypeDef,
    ExportEC2InstanceRecommendationsResponseTypeDef,
    FilterTypeDef,
    GetAutoScalingGroupRecommendationsResponseTypeDef,
    GetEBSVolumeRecommendationsResponseTypeDef,
    GetEC2InstanceRecommendationsResponseTypeDef,
    GetEC2RecommendationProjectedMetricsResponseTypeDef,
    GetEnrollmentStatusResponseTypeDef,
    GetLambdaFunctionRecommendationsResponseTypeDef,
    GetRecommendationErrorTypeDef,
    GetRecommendationSummariesResponseTypeDef,
    InstanceRecommendationOptionTypeDef,
    InstanceRecommendationTypeDef,
    JobFilterTypeDef,
    LambdaFunctionMemoryProjectedMetricTypeDef,
    LambdaFunctionMemoryRecommendationOptionTypeDef,
    LambdaFunctionRecommendationFilterTypeDef,
    LambdaFunctionRecommendationTypeDef,
    LambdaFunctionUtilizationMetricTypeDef,
    ProjectedMetricTypeDef,
    ReasonCodeSummaryTypeDef,
    RecommendationExportJobTypeDef,
    RecommendationSourceTypeDef,
    RecommendationSummaryTypeDef,
    RecommendedOptionProjectedMetricTypeDef,
    S3DestinationConfigTypeDef,
    S3DestinationTypeDef,
    SummaryTypeDef,
    UpdateEnrollmentStatusResponseTypeDef,
    UtilizationMetricTypeDef,
    VolumeConfigurationTypeDef,
    VolumeRecommendationOptionTypeDef,
    VolumeRecommendationTypeDef,
)

def get_structure() -> AutoScalingGroupConfigurationTypeDef:
    return {
      ...
    }
```
